<?php
/* ******************************************************************************
	Flux RSS  partir des donnes de central_display (par Nicolas Alves (http://www.c6guppy.org/))
	Crer par HPSAM le 24/04/2006 : http://www.hpsam.info
	Version 1 du 25/04/2006

	Installation : Il suffit de copier ce fichier  la racine du site
	Configuration : Pour les lments  afficher, il utilise la config de plugafork,
		Pour la dure de mise en cache, modifier la valeur de '$dureeCache'
		Pour la longueur de texte  garder, modifier $longueur1  4
	Utilisation : Appeler l'adresse http://www.monsite.ext/cd_rss.php?lng=fr
		lng=fr est le paramtre stipulant la langue du flux, si omis ou invalide, la langue principale
		sera utilise. Remplacer fr par le paramtre souhait.
	Le script crera un fichier xml (le cache) par langue, dans le rpertoire data (ex:cd_rss-fr.xml)
*********************************************************************************** */
$dureeCache = 600; // duree de la mise en cache en secondre
$longueur1 = 200; // longueur de texte garde pour les nouvelles et le livre d'or.
$longueur2 = 200; // longueur de texte garde pour la faq, les articles, les ractions, les liens, les tlchargements, les photos
$longueur3 = 200; // longueur de texte garde pour le forum
$longueur4 = 200; // longueur de texte garde pour les vnements

define("CHEMIN", "");
include(CHEMIN."inc/reglobals.inc");
include(CHEMIN."data/config.inc");

if (!isset($_GET['lng'])) {
 $lng = $lang[0];
}
elseif (($lng != $lang[0]) && ($lng != $lang[1])) {
 $lng = $lang[0];
}
else {$lng = $_GET['lng'];}

$fichierCache = CHEMIN."data/cd_rss-".$lng.".xml";
if (!file_exists($fichierCache) || @filemtime($fichierCache)<time()-($dureeCache)) {  //si la page n'existe pas dans le cache ou si elle a expir 

include(CHEMIN."inc/functions.php");
include_once(CHEMIN."plugins/plugafork/inc/func_forks.php");

function SelectPostFileDocidByStatusRss($Fields,$var_clos,$rankdoc,$var,$searchtype) {
 global $lng,$lang,$fileid,$status,$moddate,$author,$email,$fielda1,$fielda2,$fieldb1,$fieldb2,$fieldc1,$fieldc2,$longueur1;
 $DataDB = array();
 $k = 0;
 $now_time_file= strtotime ("now");
 $file_time_futur= strtotime ("+".$var_clos." day");
 for ($i = 0; $i < count($Fields); $i++) { 
  $param_file_time=filemtime(CHEMIN.DATAREP."doc".$Fields[$i][$rankdoc].INCEXT)+($var_clos*86400);
  if ($Fields[$i][0]==$searchtype and $param_file_time >=$now_time_file and $param_file_time < $file_time_futur) {
   ReadDoc(DBBASE.$Fields[$i][$rankdoc]);
   if($status=="a"){
    $affiche_0 = SplitText(strip_tags($fieldc1),$longueur1);
	$affiche_1 = SplitText(strip_tags($fieldc2),$longueur1);  
	$DataDB[$k][0] = $fileid;
	$DataDB[$k][1] = date("r",strtotime(ereg_replace('^([0-9]{4})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})$','\\2/\\3/\\1 \\4:\\5:00 +0200', $moddate))); // FormatDate($moddate);
	if($var==1){
	 $DataDB[$k][2]=strip_tags(html_entity_decode($author));
	 $DataDB[$k][3]=html_entity_decode($affiche_0[0]);// texte tronqu premire langue
	}
    else {
	 if ($lng==$lang[0]){
	  $DataDB[$k][2]=strip_tags(html_entity_decode($fieldb1));// titre 1ere langue
	  $DataDB[$k][3]=html_entity_decode($affiche_0[0]);// texte tronqu premire langue
	 }
	 else {
	  $DataDB[$k][2]=strip_tags(html_entity_decode($fieldb2));// titre 2eme langue
	  $DataDB[$k][3]=html_entity_decode($affiche_1[0]);// texte tronqu deuxime langue
	 }
	}
    $k++;
   }
  }
 }
 return $DataDB;
}

function SelectPostFileByStatusRss($Fields,$var_clos,$rankdoc,$var) {
 global $lng,$lang,$fileid,$status,$moddate,$author,$email,$fielda1,$fielda2,$fieldb1,$fieldb2,$fieldc1,$fieldc2,$longueur2;
 $DataDB = array();
 $k = 0;
 $now_time_file= strtotime ("now");
 $file_time_futur= strtotime ("+".$var_clos." day");
 for ($i = 0; $i < count($Fields); $i++) {
  $param_file_time=@filemtime(CHEMIN.DATAREP."doc".$Fields[$i][$rankdoc].INCEXT)+($var_clos*86400);
  if ($param_file_time >=$now_time_file and $param_file_time < $file_time_futur) {
   ReadDoc(DBBASE.$Fields [$i][$rankdoc]);
   if($status=="a"){
    $affiche_0 = SplitText(strip_tags($fieldc1),$longueur2);
	$affiche_1 = SplitText(strip_tags($fieldc2),$longueur2); 
	$DataDB[$k][0] = $fileid;
	$DataDB[$k][1] = date("r",strtotime(ereg_replace('^([0-9]{4})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})$','\\2/\\3/\\1 \\4:\\5:00 +0200', $moddate))); // FormatDate($moddate);
	if(empty($var)){
	 if($lng==$lang[0]){
      $DataDB[$k][2]=strip_tags(html_entity_decode($fieldb1));// titre premire langue
      $DataDB[$k][3]=html_entity_decode($affiche_0[0]);// texte tronqu premire langue
	 }else{
      $DataDB[$k][2]=strip_tags(html_entity_decode($fieldb2));// titre seconde langue
	  $DataDB[$k][3]=html_entity_decode($affiche_1[0]);// texte tronqu seconde langue
	 }
	}
	elseif($var==2){
	 $DataDB[$k][0]=$fielda2;
	 $DataDB[$k][2]=strip_tags(html_entity_decode($author));
	 $DataDB[$k][3]=html_entity_decode($affiche_0[0]);// texte tronqu premire langue
	}
    else{
	 $DataDB[$k][2]=strip_tags(html_entity_decode($author));
	 $DataDB[$k][3]=html_entity_decode($affiche_1[0]);// texte tronqu deuxime langue
	}
    $k++;
   }
  }
 }
 return $DataDB;
}

function RssItems($Varfields,$Titretexte,$Var_link,$var_img,$var_temps) {
 global $lng,$site;
 if (!empty($Varfields)) {
  $xmlfct = '';
  for ($i = count($Varfields)-1; $i >= 0; $i--) {
   $xmlfct .= '<item>';
   $xmlfct .= '<title><![CDATA['.$var_img.'> '.$Varfields[$i][2].']]></title>';
   $xmlfct .= '<link>'.$site[16].$Var_link.'.php?lng='.$lng.'&amp;pg='.$Varfields[$i][0].'</link>';
   $xmlfct .= '<pubDate>'.$Varfields[$i][1].'</pubDate>'; 
   $xmlfct .= '<description><![CDATA['.$Varfields[$i][3].']]></description>';
   $xmlfct .= '</item>';	
  }
 return $xmlfct;
 }
}

if ($config_forks[5]!="") {
$dbworkRss_faq = SelectPostFileByStatusRss(ReadDBFields(DBFAQ),$config_forks[5],4,"");
}
if ($config_forks[3]!="") {
$dbworkRss_art = SelectPostFileByStatusRss(ReadDBFields(DBART),$config_forks[3],4,"");
}
if ($config_forks[6]!="") {
$dbworkRss_link = SelectPostFileByStatusRss(ReadDBFields(DBLINKS),$config_forks[6],4,"");
}
if ($config_forks[7]!="") {
$dbworkRss_dwnld = SelectPostFileByStatusRss(ReadDBFields(DBDNLOAD),$config_forks[7],4,"");
}
if ($config_forks[9]!="") {
$dbworkRss_reac = SelectPostFileByStatusRss(ReadDBFields(DBREACT),$config_forks[9],0,2);
}
if ($config_forks[8]!="") {
$dbworkRss_guest = SelectPostFileDocidByStatusRss(ReadDBFields(DOCID),$config_forks[8],1,1,TYP_GUESTBK);
}
if ($config_forks[4]!="") {
$dbworkRss_news = SelectPostFileDocidByStatusRss(ReadDBFields(DOCID),$config_forks[4],1,"",TYP_NEWS);
}
if ($config_forks[11]!="") {
$dbworkRss_photo = SelectPostFileByStatusRss(ReadDBFields(DBPHOTO),$config_forks[11],4,"");
}

$xml .= '<?xml version="1.0" encoding="iso-8859-1"?><rss version="2.0">';
$xml .= '<channel>'; 
$xml .= '<title><![CDATA['.html_entity_decode($site[0]).']]></title>';
$xml .= '<link>'.$site[16].'</link>';
$xml .= '<description><![CDATA['.html_entity_decode($site[1]).']]></description>';
$xml .= '<copyright><![CDATA['.html_entity_decode($site[14]).']]></copyright>';
$xml .= '<language>'.$lng.'</language>';
$jourdui= date("D, d M Y H:i:s +0100");
//Sat, 23 Apr 2005 00:01:00 +0100
$xml .= '<pubdate>'.$jourdui.'</pubdate>';

if (!empty($dbworkRss_news)) {
$xml.= RssItems($dbworkRss_news,$forks_web4,"news","news",$config_forks[4]);
}

if ($config_forks[10]!="") {
 $dbworkRss_forum = ReadDBFields(DBTHREAD);
 if (!empty($dbworkRss_forum)) {
  // ajout hpsam : correction du problme de l'affichage de la rubrique du forum
  if ($lng == $lang[0]) { $l = 0; }
  else { $l = 1; }
  // FIN ajout hpsam : correction du problme de l'affichage de la rubrique du forum
  if(empty($config_forks[13])){$config_forks[13]="10";}
  if ($serviz[18] == "on") {
   $dbworkcat = ReadDBFields(DBFORUMCAT);
  }
  $dbfor = ReadDBFields(DBFORUM);
  $dbmess = array();
  $j = 0;
  $now_time_file= strtotime ("now");
  $file_time_futur= strtotime ("+".$config_forks[10]." day");
  for ($i = count($dbworkRss_forum)-1; $i >= Max(0,count($dbworkRss_forum)- $config_forks[13]); $i--) {
   $param_file_time=@filemtime(CHEMIN.DATAREP."doc".$dbworkRss_forum[$i][3].INCEXT)+($config_forks[10]*86400);
   if ($param_file_time >=$now_time_file and $param_file_time < $file_time_futur) {    
  	ReadDoc(DBBASE.$dbworkRss_forum[$i][3]);
    if ($fielda2 == "0") {
     $dbmess[$j][0] = $fileid;
    }
    else {
     for ($k = 0; $k < count($dbfor); $k++) {
      if ($fielda1 == $dbfor[$k][1]) {
       $fieldb2 = $dbfor[$k][12];
       $dbmess[$j][0] = $dbfor[$k][2];
      }
     }
    }
    $dbmess[$j][1] = $fieldb2;
    for ($k = 0; $k < count($dbworkcat); $k++) {
     if ($dbworkcat[$k][0] == $fieldb2) {
      $dbmess[$j][2] = $dbworkcat[$k][$l+1];
     }
    }
    $tabc = SplitText(strip_tags($fieldc1),$longueur3);
    $dbmess[$j][3] = $tabc[0];
    $dbmess[$j][4] = date("r",strtotime(ereg_replace('^([0-9]{4})([0-9]{2})([0-9]{2})([0-9]{2})([0-9]{2})$','\\2/\\3/\\1 \\4:\\5:00 +0200', $creadate))); 
    $j++;
   }
  }

  if(!empty($dbmess)){
   if($config_forks[12] =="c6"){
    $goto="plugins/forum/";
   }
   elseif($config_forks[12] =="cf"){
    $goto="plugins/coolforum/";
   }
   else{
    $goto="";		
   }	
	
   for ($i = 0; $i < count($dbmess); $i++) {
    if ($serviz[18] == "on") {
	 $star = strrpos($dbmess[$i][2], '*');
	 if($star !=0) {
	  $dbmess[$i][2] = substr($dbmess[$i][2],0,$star);
	 }
     $xml .= '<item>';
     $xml .= '<title><![CDATA[Forum> '.html_entity_decode($dbmess[$i][2]).']]></title>';
     $xml .= '<link>'.$site[16].$goto.'thread.php?lng='.$lng.'&amp;pg='.$dbmess[$i][0].'&amp;cat='.$dbmess[$i][1].'</link>';
	 $xml .= '<pubDate>'.$dbmess[$i][4].'</pubDate>'; 
     $xml .= '<description><![CDATA['.html_entity_decode($dbmess[$i][3]).']]></description>';
     $xml .= '</item>';
	}
    else {
	 $xml .= '<item>';
     $xml .= '<title><![CDATA[Forum> '.html_entity_decode($dbmess[$i][0]).']]></title>';
     $xml .= '<link>'.$site[16].$goto.'thread.php?lng='.$lng.'&amp;pg='.$dbmess[$i][0].'</link>';
	 $xml .= '<pubDate>'.$dbmess[$i][4].'</pubDate>'; 
     $xml .= '<description><![CDATA['.html_entity_decode($dbmess[$i][3]).']]></description>';
     $xml .= '</item>';
    }
   }
  }
 }
}

if (!empty($dbworkRss_art)) {
$xml.= RssItems($dbworkRss_art,$forks_web5,"articles","articles",$config_forks[3]);
}
if (!empty($dbworkRss_reac)) {
$xml.= RssItems($dbworkRss_reac,$forks_web6,"articles","reaction",$config_forks[9]);
}
if (!empty($dbworkRss_link)) {
$xml.= RssItems($dbworkRss_link,$forks_web7,"links","links",$config_forks[6]);
}
if (!empty($dbworkRss_dwnld)) {
$xml.= RssItems($dbworkRss_dwnld,$forks_web8,"download","download",$config_forks[7]);
}
if (!empty($dbworkRss_guest)) {
$xml.= RssItems($dbworkRss_guest,$forks_web9,"guestbk","guestbk",$config_forks[8]);
}
if (!empty($dbworkRss_photo)) {
if ($serviz[21] == "on") {
    $fotoname = "photorama";
  }
  else {
    $fotoname = "photos";
  }
$xml.= RssItems($dbworkRss_photo,$forks_web10,$fotoname,"photo",$config_forks[11]);
}
if (!empty($dbworkRss_faq)) {
$xml.= RssItems($dbworkRss_faq,$forks_web11,"faq","faq",$config_forks[5]);
}

if ($config_forks[19]!="" || $config_forks[20]!="") {
 $dbworkRss_agenda = ReadDBFields(DBAGENDA);
 if (!empty($dbworkRss_agenda)) {
  $DataDB = array();
  $k = 0;
  $event_time_past= strtotime (date("m/d/Y"))-($config_forks[19]*86400);
  $event_time_futur= strtotime (date("m/d/Y"))+($config_forks[20]*86400);
  for ($i = 0; $i < count($dbworkRss_agenda); $i++) {
   $param_file_time=strtotime(ereg_replace('^([0-9]{2})/([0-9]{2})/([0-9]{4})$','\\2/\\1/\\3', $dbworkRss_agenda[$i][0]));
   if ($param_file_time >= $event_time_past and $param_file_time <= $event_time_futur) {
    ReadDoc(DBBASE.$dbworkRss_agenda[$i][4]);
    if($status=="a"){
     $affiche_0 = SplitText(strip_tags($fieldc1),$longueur4);
	 $affiche_1 = SplitText(strip_tags($fieldc2),$longueur4); 
	 $DataDB[$k][0] = $fileid;
	 $DataDB[$k][1] = html_entity_decode($author);
	 $DataDB[$k][2]=$fielda1;// date de l'vnement
	 if($lng==$lang[0]){
      $DataDB[$k][3]=html_entity_decode($affiche_0[0]);// texte tronqu premire langue
	 }else{
	  $DataDB[$k][3]=html_entity_decode($affiche_1[0]);// texte tronqu seconde langue
	 }
	 $DataDB[$k][4]=$param_file_time; //timestamp pour trier
	 $k++;
    }
   }
  }
  function compare2($a, $b) {
   if ($a[4] == $b[4]) {
    return 0;
   }
   return ($a[4] > $b[4]) ? -1 : 1;
  }
  usort($DataDB, "compare2");
  $dbworkRss_agenda = $DataDB;
  
  if (!empty($dbworkRss_agenda)) {
   for ($i = count($dbworkRss_agenda)-1; $i >= 0; $i--) {
    $xml .= '<item>';
    $xml .= '<title>Agenda> '.$dbworkRss_agenda[$i][2].'</title>';
    $xml .= '<link>'.$site[16].'agenda.php?lng='.$lng.'&amp;pg='.$dbworkRss_agenda[$i][0].'&amp;agv=1</link>';
	$xml .= '<pubDate>'.date("r",$dbworkRss_agenda[$i][4]).'</pubDate>'; 
    $xml .= '<description><![CDATA['.$dbworkRss_agenda[$i][3].']]></description>';
    $xml .= '</item>';
   }
  } 
 }
}

 $xml .= '</channel></rss>';

 $fd = fopen("$fichierCache", "w"); // on ouvre le fichier cache 
 if ($fd) { 
  fwrite($fd,$xml); // on ecrit le contenu du buffer dans le fichier cache 
  fclose($fd); 
 } 
}
 
 header("location:".$fichierCache); // on renvoi vers le fichier xml
?>